#include "Sprite.h"
#include "Window.h"
#include "Chars.h"
#include "Vram.h"

constexpr byte InvalidCode = 0xff;
Sprite[SpriteCount] Sprites;

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->code = InvalidCode;
    }
}


void ShowSprite(byte index, byte x, byte y, byte code)
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->x = x;
    p->y = y;
    p->code = code;
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->code = InvalidCode;
}


void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->code != InvalidCode) {
            ptr<byte> pFront;
            byte y, c;
            y = p->y;
            pFront = WindowPtr(p->x, y);
            c = p->code;
            pFront[0] = c; 
            if (p->code >= Char_Fighter) {
                ++c; pFront[1] = c;
                ++c; pFront[WindowWidth] = c;
                ++c; pFront[WindowWidth + 1] = c;
            }
        }
    }
}
