#include "Vram.h"
#include "Window.h"
#include "CopyMemory.h"
#include "Chars.h"

extern const byte[] Chars;

void InitVram()
{
    ClearScreen();
}


ptr<byte> PrintC(ptr<byte> pVram, byte c)
{
    VPut(pVram, c - ' ');
    return pVram + 1 * VramStep;
}


void VPut2(ptr<byte> pVram, byte c) 
{
    repeat(2) {
        repeat(2) {
            VPut(pVram, c);
            ++c;
            pVram += VramStep;
        }
        pVram += VramRowSize - VramStep * 2;
    }
}


void VErase2(ptr<byte> pVram)
{
    repeat(2) {
        repeat(2) {
            VPut(pVram, Char_Space);
            pVram += VramStep;
        }
        pVram += VramRowSize - VramStep * 2;
    }
}


void VPut4(ptr<byte> pVram, ptr<byte> pBytes)
{
    repeat (4) {
        repeat (4) {
            VPut(pVram, *pBytes);
            ++pBytes;
            pVram += VramStep;
        }
        pVram += VramRowSize - VramStep * 4;
    }
}
