constexpr byte VramWidth = 40;
constexpr byte VramHeight = 24;
constexpr byte CharHeight = 8;
constexpr byte VramStep = CharHeight;
constexpr byte VramRowSize = VramWidth * VramStep;


constexpr ptr<byte> VramOrg = (ptr<byte>)0x5800;
constexpr ptr<byte> Vram = VramOrg + VramRowSize * 3;
constexpr ptr<byte> VramLeftTop = Vram + ((VramWidth - 32) / 2) * VramStep;

extern void ClearScreen();
extern void VPut(ptr<byte> pVram, byte c);
extern void WindowToVram();
extern ptr<byte> VramPtr(byte x, byte y);

extern void InitVram();
extern ptr<byte> PrintC(ptr<byte> pVram, byte c);
extern void VPut2(ptr<byte> pVram, byte c);
extern void VErase2(ptr<byte> pVram);
extern void VPut4(ptr<byte> pVram, ptr<byte> pChars);