include 'Zeropage.inc'
include 'Vram.inc'
include 'Window.inc'

ext Window_
ext Chars_
ext FighterX_, FighterY_

VramTop equ Vram+((40-32))/2*VramStep

pSource equ ZW0
pVram equ ZW1
pWindow equ ZW2
pBackup equ ZW3
yCount equ ZB0
xOffset equ ZB1
rowFlag equ ZB2
flagOffset equ ZB3
maskBit equ ZB4

bits equ ZB0
yMod equ ZB1


dseg
Backup:
    defs WindowWidth*WindowHeight


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        lda #low VramOrg | sta pVram
        lda #high VramOrg | sta pVram+1
        lda #0
        ldx #$80-high VramOrg
        do
            ldy #0
            do
                sta (<pVram),y
                iny
            while ne | wend
            inc <pVram+1
            dex
        while ne | wend

        lda #low Backup | sta <pVram
        lda #high Backup | sta <pVram+1
        ldx #WindowHeight
        do
            lda #0
            ldy #0
            do
                sta (<pVram),y
                iny
                cpy #WindowWidth
            while ne | wend
            lda <pVram | clc|adc #WindowWidth | sta <pVram
            lda <pVram+1 | adc #0 | sta <pVram+1
            dex
        while ne | wend
    pla
rts


cseg
Put1:
    sta <pSource
    lda #0 | sta <pSource+1
    asl <pSource | rol <pSource+1 ; *2
    asl <pSource | rol <pSource+1 ; *4
    asl <pSource | rol <pSource+1 ; *8
    lda <pSource | clc|adc #low Chars_ | sta <pSource
    lda <pSource+1 | adc #high Chars_ sta <pSource+1
    ldy #0
    do
        lda (<pSource),y
        sta (<pVram),y
        iny
        cpy #CharHeight
    while ne | wend
rts


; void VPut(ptr<byte> pVram, byte c);
dseg
VPut_@Param0: public VPut_@Param0
VPut_pVram:
    defw 0
VPut_@Param1: public VPut_@Param1
VPut_c:
    defb 0
cseg
VPut_: public VPut_
    pha
        lda VPut_pVram | sta <pVram
        lda VPut_pVram+1 | sta <pVram+1
        
        lda VPut_c
        jsr Put1
    pla
rts


; ; void WindowToVram();
cseg
WindowToVram_: public WindowToVram_
    pha
        lda #low Window_ | sta <pWindow
        lda #high Window_ | sta <pWindow+1
        lda #low VramTop | sta <pVram
        lda #high VramTop | sta <pVram+1
        lda #low Backup | sta <pBackup
        lda #high Backup | sta <pBackup+1
        lda #WindowHeight | sta <yCount
        do
            ldy #0
            do
                lda (<pWindow),y
                cmp (<pBackup),y
                if ne
                    sta (<pBackup),y
                    sty <xOffset
                    jsr Put1
                    ldy <xOffset
                endif
                lda <pVram | clc | adc #low CharHeight | sta <pVram
                lda <pVram+1 | adc #high CharHeight | sta <pVram+1

                iny
                cpy #WindowWidth
            while ne | wend

            lda <pVram | clc | adc #low(CharHeight*(VramWidth-WindowWidth)) | sta <pVram
            lda <pVram+1 | adc #high(CharHeight*(VramWidth-WindowWidth)) | sta <pVram+1

            lda <pWindow | clc | adc #low WindowWidth | sta <pWindow
            lda <pWindow+1 | adc #high WindowWidth | sta <pWindow+1

            lda <pBackup | clc | adc #low WindowWidth | sta <pBackup
            lda <pBackup+1 | adc #high WindowWidth | sta <pBackup+1

            dec <yCount
        while ne | wend
    pla
rts


; word VramPtr(byte x, byte y)
dseg
VramPtr_@Param0: public	VramPtr_@Param0
VramPtr_.x_:	defs 1
VramPtr_@Param1: public	VramPtr_@Param1
VramPtr_.y_:	defs 1
cseg
VramPtr_: public	VramPtr_
	pha
        lda	VramPtr_.y_
        asl a ; *2
        asl a ; *4
        adc	VramPtr_.y_ ; *5
        sta <pVram | lda #0 | sta <pVram+1
        asl <pVram | rol <pVram+1 ;10
        asl <pVram | rol <pVram+1 ;20
        asl <pVram | rol <pVram+1 ;40
        lda <pVram | clc | adc VramPtr_.x_ | sta <pVram
        lda <pVram+1 | adc #0 | sta <pVram+1
        asl <pVram | rol <pVram+1 ;2
        asl <pVram | rol <pVram+1 ;4
        asl <pVram | rol <pVram+1 ;8
        lda <pVram | clc|adc #low Vram | tay
        lda <pVram+1 | adc #high Vram | tax
	pla
rts


; void DrawFighterOnRader();
cseg
DrawFighterOnRader_: public DrawFighterOnRader_
    pha
        lda #$80 | sta <bits
        lda FighterX_
        sec|sbc #1
        lsr a
        pha
            and #3 | tax
            do
            while ne
                lsr <bits
                dex
            wend
        pla
        lsr a | lsr a
        clc|adc #28
        sta VramPtr_@Param0

        lda FighterY_
        sec|sbc #1
        and #$fe
        pha
            and #$06 | sta <yMod
        pla
        lsr a | lsr a | lsr a
        clc|adc #12
        sta VramPtr_@Param1
        jsr VramPtr_ | sty <pVram | stx <pVram+1

        ldy <yMod
        lda (<pVram),y | eor <bits | sta (<pVram),y
        iny
        lda (<pVram),y | eor <bits | sta (<pVram),y
	pla
rts
